# -*- coding: utf-8 -*-
# Raumplaner.py
"""App zum Projekt mit schrittweiser Ausfuehrung mit eigener Klasse Schritte"""

from schritte import Schritte

from grafikfenster import *

from stuhl import Stuhl
from tisch import Tisch

### ---------------------------------------------------
class MyApp(wx.App):
    """Testanwendung fuer Raumplaner-Grafik"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        #self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        ##Zeichenflaeche.GibZeichenflaeche().SetBGImage('beispielbild.png',0.8)
        ##Zeichenflaeche.GibZeichenflaeche().SetBGColor('BLACK')
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Testanwendung mit eigener Klasse Schritte"""
        print(__doc__)
        print("App-Attribute stuhl, tisch")
        self.tisch=Tisch(sichtbar=True)
        self.stuhl=Stuhl(sichtbar=True)
        self.Schrittweise()
        
    def SchrittProzedur(self):
        '''definiert, was in jedem Schritt zu tun ist'''
        self.tisch.BewegeHorizontal(2)
        self.tisch.BewegeVertikal(3)
        self.stuhl.BewegeHorizontal(1)
        self.stuhl.BewegeVertikal(5)
        self.stuhl.Drehe(3)

    def Schrittweise(self):
        '''verwendet die eigenstaendige Klasse Schritte'''
        self.schritte=Schritte(self, 30, self.SchrittProzedur)
        self.schritte.Start(100)

### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
